local sti = require "sti"
require ('camera')
bump = require 'bump.bump'

sprClock = 0
acc = 10
gravity = 475
infoText = "Use ARROW KEYS to move aro- \nund, jump to hide"

player ={
	yV = 0,
	x = 160,
	y = 300,
	jumpAcc = 500,
	jumpMaxSpeed = 9.5,
	yacc = 0.9,
	yNew = 300,
	img = nil,
	maxSpeed = 1,

}

function love.load()
	love.graphics.setNewFont("assets/8bitOperatorPlusSC-Regular.ttf", 15)
	BGmusic = love.audio.newSource("assets/BG_Music.wav")
	Jump = love.audio.newSource("assets/jump.wav")
	BGmusic:setLooping(true)
	BGmusic:play()
	player.img = love.graphics.newImage('assets/sp1.png')
	world = bump.newWorld(32)
	map = sti("CastleMapA1.lua", { 'bump' })
	world:add(player, player.x, player.y, 28, 32)
	map:bump_init(world)
	love.graphics.setBackgroundColor( 50, 50, 50)
end

function love.update(dt)
--Sprite updating
	sprClock = sprClock + dt
	if sprClock > 0.1666 then
		player.img = love.graphics.newImage('assets/sp2.png') 
		if sprClock > 0.3333 then
			player.img = love.graphics.newImage('assets/sp3.png')
			if sprClock > 0.5 then
				player.img = love.graphics.newImage('assets/sp4.png')
				if sprClock > 0.6666 then
					player.img = love.graphics.newImage('assets/sp5.png')
					if sprClock > 0.8333 then
						player.img = love.graphics.newImage('assets/sp6.png')
						if sprClock >= 1 then
							player.img = love.graphics.newImage('assets/sp1.png')
							sprClock = 0
						end
					end	
				end			
			end
		end
	end
--End Sprite updating Section

--Updating the Player's Y volocity
	player.yV = player.yV * player.yacc	
	player.y = player.y + player.yV + gravity * dt
--The decreasing value makes the game go back to 0  yV really slowly so I have it jump there a little quicker
	if player.yV > -0.1 then
		player.yV = 0
	end
--Checking if the player is pushing a button that way we can move the character, the jumping action fails if they aren't grounded	
	if love.keyboard.isDown('up', 'w') and not player.nGounded then
	infoText = ""
	Jump:play()
		player.yV = -45
	end
	if love.keyboard.isDown('left', 'a') then
		player.x = player.x - 350 * dt
	elseif love.keyboard.isDown('right','d') then
		player.x = player.x + 350 *dt
	end	
--	if love.keyboard.isDown('up', 'w') and not player.nGounded then
--	infoText = ""
--	Jump:play()
--		player.yV = -45
--	end
--If the player wants to quit they can hit the ESCAPE button
	if love.keyboard.isDown('escape') then
		love.event.push('quit')
	end
--Conditionals checking if the player is grounded	
	player.yNew = player.y
	player.x, player.y, collisions = world:move(player, player.x, player.y)		
	if player.y == player.yNew then
		player.nGounded = true
	elseif player.y ~= player.yNew then
		player.nGounded = false
	end
	
	
-- Game Over Conditionals
	if player.y > 2000 then
		infoText = "GAME OVER \n \n Press ESC to Quit"
	end

--Updating the camera and map through the camera and bump/sti modules	
	camera:scale(1,1)
	camera:setPosition(player.x - love.graphics.getWidth() / 2, player.y - love.graphics.getHeight() / 2)
	map:update(dt)
--	camera:scale(1,1)
end

function love.draw(dt)
	camera:set()
	map:draw(-camera._x, -camera._y)
	love.graphics.draw(player.img, player.x, player.y)	
	love.graphics.print(infoText, player.x, player.y + 50)	
	camera:unset()
end